Skip to main content
`Ctrl`+`K`

# SNESConvergenceTestFunction

functional form used for testing of convergence of nonlinear solver

## Synopsis

    #include <petscsnes.h>
    PetscErrorCode SNESConvergenceTest(SNES snes, PetscInt it, PetscReal xnorm, PetscReal gnorm, PetscReal f, SNESConvergedReason *reason, void *cctx)

Collective

## Input Parameters

- snes - the `SNES` context

- it - current iteration (0 is the first and is before any Newton step)

- xnorm - 2-norm of current iterate

- gnorm - 2-norm of current step

- f - 2-norm of function

- cctx - [optional] convergence context

## Output Parameter

- reason - reason for convergence/divergence, only needs to be set when convergence or divergence is detected

## See Also

SNES: Nonlinear Solvers, `SNES`, `SNESSolve`, `SNESSetConvergenceTest()`

## Level

intermediate

## Location

src/snes/interface/snes.c

Index of all SNES routines
Table of Contents for all manual pages
Index of all manual pages